﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using System.Data;

public partial class Grid_Filtering_MultipleValuesForField : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    private string[] parts = new string[] { "Jim", "David", "George", "Bob" };

    protected void RadGrid1_NeedDataSource(object sender, GridNeedDataSourceEventArgs e)
    {
        DataTable data = new DataTable();
        data.Columns.Add("Title", typeof(string));

        data.Rows.Add(parts[0] + " " + parts[1] + " " + parts[2]);
        data.Rows.Add(parts[0] + " " + parts[1] + " " + parts[3]);
        data.Rows.Add(parts[1] + " " + parts[3] + " " + parts[2]);
        data.Rows.Add(parts[3] + " " + parts[1] + " " + parts[2]);
        data.Rows.Add(parts[0] + " " + parts[3] + " " + parts[2]);
        data.Rows.Add(parts[3] + " " + parts[1] + " " + parts[2]);
        data.Rows.Add(parts[0] + " " + parts[1] + " " + parts[2]);
        data.Rows.Add(parts[3] + " " + parts[2] + " " + parts[1]);
        data.Rows.Add(parts[2] + " " + parts[3] + " " + parts[1]);
        data.Rows.Add(parts[2] + " " + parts[1] + " " + parts[3]);
        data.Rows.Add(parts[0] + " " + parts[2] + " " + parts[2]);
        data.Rows.Add(parts[2] + " " + parts[1] + " " + parts[0]);

        RadGrid1.DataSource = data;
    }

    List<string> selected = new List<string>();
    protected void FilterCheckBoxList_Load(object sender, EventArgs e)
    {
        CheckBoxList list = (CheckBoxList)sender;
        foreach (ListItem item in list.Items)
        {
            if (item.Selected)
            {
                selected.Add(item.Value);
            }
        }

        list.DataSource = parts;
        list.DataBind();
    }

    protected void FilterCheckBoxList_DataBound(object sender, EventArgs e)
    {
        CheckBoxList list = (CheckBoxList)sender;
        foreach (ListItem item in list.Items)
        {
            item.Selected = selected.Contains(item.Value);
        }
    }

    protected void FilterButton_Click(object sender, EventArgs e)
    {
        Button button = (Button)sender;
        CheckBoxList chkBoxList = (CheckBoxList)button.Parent.FindControl("FilterCheckBoxList");

        string filterExpression = "";
        foreach (ListItem item in chkBoxList.Items)
        {
            if (item.Selected)
            {
                filterExpression += String.Format("([Title] LIKE '%{0}%') AND", item.Value);
            }
        }

        if (filterExpression != "")
        {
            filterExpression = String.Format("({0})", filterExpression.Substring(0, filterExpression.Length - 4));
        }        

        RadGrid1.MasterTableView.FilterExpression = filterExpression;
        RadGrid1.Rebind();
    }
}
